﻿namespace sample
open System
open System.Collections.Generic
open System.Windows.Forms
open System.Threading
open System.Drawing
open System.Drawing.Imaging
open OpenTK
open OpenTK.Graphics
open OpenTK.Graphics.OpenGL
open Shape

type loopForm() as form=
    inherit Form()
    let caram = Shape.Camera()

    let offest = 0.1f
    let offestd = float offest
    let glControl = new OpenTK.GLControl()
    let mutable light0 = Shape.HLight(LightName.Light0)
    let mutable light1 = Shape.HLight(LightName.Light1)
    let mutable light2 = Shape.HLight(LightName.Light2)
    let mutable light3 = Shape.HLight(LightName.Light3)
    let mutable light4 = Shape.HLight(LightName.Light4)
    let mutable light5 = Shape.HLight(LightName.Light5)

    let cubeEnter = Shape.Cube(1.5f,0.2f,1.8f,3)
    let cubeParlor = Shape.Cube(4.0f,0.2f,6.3f,3)
    let cubeBalcony1 = Shape.Cube(4.9f,0.2f,1.9f,3)
    let cubeBalcony2 = Shape.Cube(1.6f,0.2f,2.1f,3)
    let cubeBalcony3 = Shape.Cube(1.8f,0.2f,3.0f,3)
    let cubeKitchen = Shape.Cube(4.5f,0.2f,1.8f,3)
    let cubeBathroom = Shape.Cube(2.1f,0.2f,2.1f,3)
    let cubeGallery = Shape.Cube(2.1f,0.2f,1.2f,3)
    let cubeMasterBedroom = Shape.Cube(3.6f,0.2f,3.9f,3)
    let cubeSecondbedroom = Shape.Cube(3.0f,0.2f,3.3f,3)

    let cubeWall1 = Shape.Cube(0.2f,3.f,8.1f,0)
    let cubeWall2 = Shape.Cube(4.5f,3.f,0.2f,0)
    let cubeWall3 = Shape.Cube(0.2f,3.f,1.8f,0)
    let cubeWall4 = Shape.Cube(0.2f,1.8f,1.8f,0)
    let cubeWall5 = Shape.Cube(3.0f,3.f,0.2f,0)
    let cubeWall6 = Shape.Cube(0.2f,3.f,3.7f,0)
    let cubeBathroom1 = Shape.Cube(2.1f,3.f,0.2f,0)
    let cubeBathroom2 = Shape.Cube(0.2f,3.f,2.1f,0)
    let cubeFence1 = Shape.Cube(0.1f,0.02f,1.9f,0)
    let cubeFence2 = Shape.Cube(2.3f,0.02f,0.1f,0)
    let cubeFence3 = Shape.Cube(0.1f,0.02f,2.1f,0)
    let cubeFence4 = Shape.Cube(3.4f,0.02f,0.1f,0)
    let cubeWall7 = Shape.Cube(2.1f,3.f,0.2f,4)
    let cubeWall8 = Shape.Cube(0.2f,3.f,3.0f,0)
    let cubePillar = Shape.Cube(0.2f,3.f,0.2f,4)
    let cubePillar2 = Shape.Cube(0.1f,1.1f,0.2f,4)

    let sphereHead = Shape.Sphere(0.15f,3)
    let cubePeople = Shape.Cube(0.2f,1.3f,0.1f,3)
    let cubePeople1 = Shape.Cube(0.6f,0.2f,0.1f,-1)
    let mutable oldMouseLocation = Vector2.Zero
    let mutable texture = 0
    let str= Environment.CurrentDirectory;
    
    let path = [|
                          str + @"\a白墙.jpg"
                          str + @"\a电视墙.jpg"
                          str + @"\客1.jpg"
                          str + @"\阳台.jpg"
                          str + @"\厨房.jpg"
                          str + @"\浴室.jpg"
                          str + @"\卧室.jpg"
                    |]
    let mutable texs = Array.create path.Length 0     
    do
        printfn "%s" str
        form.SuspendLayout()
        glControl.Location <- new Point(10,40)
        glControl.Size <- new Size(800,600)
        glControl.BackColor <- Color.Red
        glControl.Resize.Add(form.resize)
        glControl.Paint.Add(form.paint)
        glControl.KeyDown.Add(form.KeyDown)
        glControl.MouseMove.Add(form.MouseDownv)
        form.ClientSize <- new Size(900,700)
        form.Text <- "opengl"
        //form.StartPosition <- FormStartPosition.Manual
        form.Location <- new Point(1200,600)
        form.Controls.Add(glControl)
        form.ResumeLayout(false)
        //#endregion 
    override v.OnLoad e =
        Application.Idle.Add(v.AIdle)
        GL.ClearColor Color.MidnightBlue
        GL.Enable( EnableCap.Texture2D)
        GL.Enable(EnableCap.DepthTest)
        GL.EnableClientState(ArrayCap.VertexArray)
        GL.EnableClientState(ArrayCap.NormalArray) 
        GL.Hint(HintTarget.PerspectiveCorrectionHint, HintMode.Nicest)
        texs <- TexTure.Load(path)
        caram.Transelt(0.4,1.7,0.)
        GL.PolygonMode(MaterialFace.Front,PolygonMode.Fill)
        //GL.PolygonMode(MaterialFace.Back,PolygonMode.Fill)
        GL.Enable(EnableCap.Lighting)
        //全局环境光
        GL.LightModel(LightModelParameter.LightModelAmbient,[|0.3f;0.3f;0.3f;1.f|])
        //把镜面颜色的计算推迟到纹理贴图后
        GL.LightModel(LightModelParameter.LightModelColorControl,int All.SeparateSpecularColor)
        //
        light0.Location <- [|20.f;20.f;20.f;0.f|]
        light0.Ambient <- [|0.5f;0.5f;0.5f;0.5f|]
        light0.IsOpen <- true
        light0.Light()
        light1 <- light0.Copy(LightName.Light1)
        light1.Location <- [|0.5f;3.f;0.5f;1.f|]
        light1.Ambient <- [|0.5f;0.5f;0.5f;0.5f|]
        light1.Light()
        light2 <- light0.Copy(LightName.Light2)
        light2.Location <- [|0.5f;3.f;0.5f;1.f|]
        light2.Ambient <- [|0.5f;0.5f;0.5f;0.5f|]
        light2.Light()
        light3 <- light0.Copy(LightName.Light3)
        light3.Location <- [|0.5f;3.f;0.5f;1.f|]
        light3.Ambient <- [|0.5f;0.5f;0.5f;0.5f|]
        light3.Light()
//#region
    override v.OnClosing e =
        base.OnClosing e
    member v.resize (e:EventArgs) =
        GL.Viewport(0,0,glControl.ClientSize.Width,glControl.ClientSize.Height)
        let aspect = float32 glControl.ClientSize.Width /float32 glControl.ClientSize.Height
        let mutable projection = Matrix4.CreatePerspectiveFieldOfView(MathHelper.PiOver2,aspect,0.1f,30.f)
        GL.MatrixMode MatrixMode.Projection
        GL.LoadMatrix(&projection)
    member v.paint (e:PaintEventArgs) =
        v.Render()
    member v.AIdle (e:EventArgs) =
        while (glControl.IsIdle) do
            v.Render()
    member v.MouseDownv(e:MouseEventArgs) =
        if e.Button = MouseButtons.Right then
            if oldMouseLocation = Vector2.Zero then
                oldMouseLocation <- Vector2(float32 e.X,float32 e.Y)
            else
                let nx = (float32 e.X - oldMouseLocation.X) * offest * 0.1f
                let ny = (float32 e.Y - oldMouseLocation.Y) * offest * -0.1f
                caram.Rotate(float nx,float ny)
        oldMouseLocation <- Vector2(float32 e.X,float32 e.Y)     
    member v.KeyDown(e:KeyEventArgs) =
        //let keys = e.KeyData
        match e.KeyCode with
        | Keys.E ->caram.Transelt(0.,0.,1.* offestd)
        | Keys.D ->caram.Transelt(0.,0.,-1.* offestd)
        | Keys.S ->caram.Transelt(1.* offestd,0.,0.0)
        | Keys.F ->caram.Transelt(-1.* offestd,0.,0.)
        | Keys.Space ->
            if e.Shift then caram.Transelt(0.,-1.* offestd,0.)
            else caram.Transelt(0.,1.* offestd,0.)
        | Keys.V ->caram.IsThree <- not caram.IsThree
        | Keys.Add -> caram.Length <- caram.Length + 0.1
        | Keys.Subtract -> caram.Length <- caram.Length - 0.1
        | _ -> ()
    member x.UIValue
        with get (text:TextBox) = 
            let mutable value = 0.f
            if System.Single.TryParse(text.Text,&value) then
                value <- value
            value
        and set (text:TextBox) (value:float32) = text.Text<- value.ToString()
//#endregion        
    member v.Render =
        GL.Clear(ClearBufferMask.ColorBufferBit ||| ClearBufferMask.DepthBufferBit)
        GL.MatrixMode(MatrixMode.Modelview) 
        let mutable lookat = Matrix4.LookAt(caram.Eye,caram.Target,Vector3.UnitY)
        GL.LoadMatrix(&lookat) 
        if caram.IsThree then 
            GL.PushMatrix() 
            GL.Translate(caram.People)  
            GL.Rotate(float32 (-caram.PeopleAngle * 180./Math.PI),Vector3.UnitY)    
            v.DrawCube(cubePeople,0.f,0.f,0.f,[|(0,texs.[0],true);(2,texs.[0],true);(4,texs.[0],true);(5,texs.[6],true)|])
            v.DrawCube(cubePeople1,0.1f,-0.1f,0.f,[|(0,texs.[0],true);(2,texs.[0],true);(4,texs.[0],true);(5,texs.[2],true)|])
            GL.PushMatrix()
            GL.Translate(0.1f,0.15f,0.0f)
            sphereHead.Draw()
            GL.PopMatrix()
            GL.PopMatrix()
//#region
        //GL.Color3(Color.White)
        //地面
        v.DrawCube(cubeEnter,0.f,0.f,0.f,1,texs.[2])
        v.DrawCube(cubeParlor,0.f,0.f,1.8f,1,texs.[2])
        v.DrawCube(cubeBalcony1,0.f,0.f,8.1f,1,texs.[3])
        v.DrawCube(cubeBalcony2,2.3f,0.f,10.f,1,texs.[3])
        v.DrawCube(cubeBalcony3,3.9f,0.f,9.f,1,texs.[3])
        v.DrawCube(cubeKitchen,1.5f,0.f,0.f,1,texs.[5])
        v.DrawCube(cubeBathroom,3.9f,0.f,1.8f,1,texs.[5])
        v.DrawCube(cubeGallery,3.9f,0.f,3.9f,1,texs.[2])
        v.DrawCube(cubeMasterBedroom,3.9f,0.f,5.1f,1,texs.[6])
        v.DrawCube(cubeSecondbedroom,6.0f,0.f,1.8f,1,texs.[6])  
        //墙
        v.DrawCube(cubeWall1,0.f,0.f,0.f,[|(0,texs.[0],true);(2,texs.[0],true);(4,texs.[0],true);(5,texs.[0],true)|])
        v.DrawCube(cubeWall2,1.5f,0.f,0.f,[|(0,texs.[4],false);(2,texs.[0],true);(4,texs.[0],true);(5,texs.[0],true)|])
        v.DrawCube(cubeWall3,1.5f,0.f,0.f,[|(0,texs.[0],true);(2,texs.[0],true);(4,texs.[4],true);(5,texs.[0],true)|])
        v.DrawCube(cubeWall4,6.0f,0.f,0.f,[|(0,texs.[0],true);(2,texs.[0],true);(4,texs.[0],true);(5,texs.[0],true)|])
        v.DrawCube(cubeWall5,6.0f,0.f,1.8f,[|(0,texs.[0],true);(2,texs.[0],true);(4,texs.[0],true);(5,texs.[0],true)|])
        v.DrawCube(cubeWall6,9.0f,0.f,1.8f,[|(0,texs.[0],true);(2,texs.[0],true);(4,texs.[0],true);(5,texs.[0],true)|])
        v.DrawCube(cubeWall6,7.5f,0.f,5.1f,[|(0,texs.[0],true);(2,texs.[0],true);(4,texs.[0],true);(5,texs.[0],true)|])
        v.DrawCube(cubeWall6,3.9f,0.f,5.1f,[|(0,texs.[0],true);(2,texs.[0],true);(4,texs.[1],true);(5,texs.[0],true)|])        
        v.DrawCube(cubeWall7,3.9f,0.f,9.0f,[|(0,texs.[0],true);(2,texs.[0],true);(4,texs.[0],true);(5,texs.[0],true)|])
        v.DrawCube(cubeWall8,5.5f,0.f,9.0f,[|(0,texs.[0],true);(2,texs.[0],true);(4,texs.[0],true);(5,texs.[0],true)|])
        v.DrawCube(cubeBathroom1,3.9f,0.f,1.8f,[|(0,texs.[5],true);(2,texs.[2],true);(4,texs.[4],true);(5,texs.[0],false)|])        
        v.DrawCube(cubeBathroom2,3.9f,0.f,1.8f,[|(0,texs.[0],true);(2,texs.[5],false);(4,texs.[1],true);(5,texs.[0],true)|])
        v.DrawCube(cubeBathroom2,6.0f,0.f,1.8f,[|(0,texs.[0],true);(2,texs.[0],true);(4,texs.[5],true);(5,texs.[0],true)|])
        v.DrawCube(cubeFence1,0.0f,1.f,8.1f,[|(0,texs.[0],true);(2,texs.[0],true);(4,texs.[0],true);(5,texs.[0],true)|])
        v.DrawCube(cubeFence2,0.0f,1.f,10.f,[|(0,texs.[0],true);(2,texs.[0],true);(4,texs.[0],true);(5,texs.[0],true)|])  
        v.DrawCube(cubeFence3,2.3f,1.f,10.f,[|(0,texs.[0],true);(2,texs.[0],true);(4,texs.[0],true);(5,texs.[0],true)|])  
        v.DrawCube(cubeFence4,2.3f,1.f,12.1f,[|(0,texs.[0],true);(2,texs.[0],true);(4,texs.[0],true);(5,texs.[0],true)|]) 
        v.DrawCube(cubePillar,2.3f,0.f,12.f,[|(0,texs.[0],true);(2,texs.[0],true);(4,texs.[0],true);(5,texs.[0],true)|])
        v.DrawCube(cubePillar,2.3f,0.f,9.9f,[|(0,texs.[0],true);(2,texs.[0],true);(4,texs.[0],true);(5,texs.[0],true)|])
        v.DrawCube(cubePillar2,0.f,0.f,9.9f,[|(0,texs.[0],true);(2,texs.[0],true);(4,texs.[0],true);(5,texs.[0],true)|])
        //房顶
        GL.PushMatrix()
        GL.Translate(0.f,3.f,0.f)
        v.DrawCube(cubeEnter,0.f,0.f,0.f,3,texs.[0],true)
        v.DrawCube(cubeParlor,0.f,0.f,1.8f,3,texs.[0],true)
        v.DrawCube(cubeBalcony1,0.f,0.f,8.1f,3,texs.[0],true)
        v.DrawCube(cubeBalcony2,2.3f,0.f,10.f,3,texs.[0],true)
        v.DrawCube(cubeBalcony3,3.9f,0.f,9.f,3,texs.[0],true)
        v.DrawCube(cubeKitchen,1.5f,0.f,0.f,3,texs.[0],true)
        v.DrawCube(cubeBathroom,3.9f,0.f,1.8f,3,texs.[0],true)
        v.DrawCube(cubeGallery,3.9f,0.f,3.9f,3,texs.[0],true)
        v.DrawCube(cubeMasterBedroom,3.9f,0.f,5.1f,3,texs.[0],true)
        v.DrawCube(cubeSecondbedroom,6.0f,0.f,1.8f,3,texs.[0],true)   
        GL.PopMatrix()        
//#endregion     
        glControl.SwapBuffers()
        ignore
    member v.DrawCube(cube:Shape.Cube,x:float32,y:float32,z:float32,index,id,?bAll:bool) =
        let ball = defaultArg bAll false
        GL.PushMatrix()
        GL.Translate(x,y,z)
        cube.DrawTexTure(index,id,ball)
        GL.PopMatrix()
    member v.DrawCube(cube:Shape.Cube,x:float32,y:float32,z:float32,its:(int*int*bool)[]) =
        GL.PushMatrix()
        GL.Translate(x,y,z)
        cube.DrawTexTure(its)
        GL.PopMatrix()
    member v.DrawCube(cube:Shape.Cube,pos:Vector3) =
        v.DrawCube(cube,pos,cube.Index)
    member v.DrawCube(cube:Shape.Cube,x,y,z) =
        v.DrawCube(cube,new Vector3(x,y,z),cube.Index)
    member v.DrawCube(cube:Shape.Cube, pos:Vector3, ind:int) =
        GL.PushMatrix()
        cube.Index <- ind
        GL.Translate(pos)
        cube.Draw()
        GL.PopMatrix()



module main =
    [<System.STAThread>]
    Application.Run(new loopForm()) |> ignore
